const express = require('express');
const cors = require('cors');
const c = require("centra");
const router = express.Router();
const { getActiveToken } = require("../lib/spotify")

router.get('/', (req, res) => {
  res.send('Spotify Module Loaded!');
});

// router.get('/tok', async (req, res) => {
//   console.log("aaa", token)
//   res.send(`Processing...`);
// });

const allowedOrigins = ["http://localhost:5173", "https://cards.elliee.me", "https://cards.jamesz.dev"]

const corsOptions = {
  origin: allowedOrigins
}

router.get('/card/track/:id', cors(corsOptions), async (req, res) => {
  const token = await getActiveToken();

  c("https://api.spotify.com/v1/tracks/"+req.params.id)
  .header("Authorization", "Bearer " + token.access_token)
  .send()
  .then(res => res.json())
  .then(data => {
    if (data.error) {
      // console.log(data);
      res.status(500).json({success: false, message: "Error while making request to Spotify."})
      return
    }
    res.status(200).json({success: true, data: {
      uri: data.uri,
      name: data.name,
      artists: data.artists.map(artist => artist?.name).join(", "),
      albumName: data.album.name,
      releaseDate: data.album.release_date.split("-")[0],
      albumImages: data.album.images,
    }});
  })
  .catch(err => {
    console.error(err);
    res.status(500).json({success: false, error: err})
  })

});


module.exports = router;